#if defined(__linux__)
#if defined(__aarch64__)

/*
 * Use Linux system call.
 */

#define SYS_exit   1
#define SYS_read   3
#define SYS_write  4
#define SYS_open   5
#define SYS_close  6
#define SYS_ioctl 54

	.section .text

	.globl	___exit
	.type	___exit, %function
___exit:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_exit
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__read
	.type	__read, %function
__read:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_read
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__write
	.type	__write, %function
__write:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_write
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__open
	.type	__open, %function
__open:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_open
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__close
	.type	__close, %function
__close:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_close
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret

	.globl	__ioctl
	.type	__ioctl, %function
__ioctl:
	sub	sp, sp, #0x32
	str	x8, [sp, #0]
	mov	x8, #SYS_ioctl
	svc	0
	ldr	x8, [sp, #0]
	add	sp, sp, #0x32
	ret
#endif
#endif
